var Cus01400_CurvaABCGeralPlanController = function(ScreenService, restEngine, maskEngine, ZhUtil, General, GeneralServices, templateManager) {
	/* global getLocalVar, Configuration, moment*/
	var self = this;

	this.idVizualiza = function(widget) {
		if(widget.getField('REPORT_NAME').value() == 'CUS01401'){
			widget.getField('IDVISUALIZA').isVisible = true;
		}else {
			widget.getField('IDVISUALIZA').isVisible = false;
		}
		templateManager.updateTemplate();
	};

	this.setaNomeRelatorio = function(widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}

		widget.currentRow.REPORT_NAME               = 'CUS01400';
		widget.currentRow.CDFILIAL                  = getLocalVar('CDFILIAL');
		widget.currentRow.NMFILIAL                  = getLocalVar('CDFILIAL') + ' | '+ getLocalVar('NMFILIAL');
		widget.currentRow.DTINTERVAL                = {};
		widget.currentRow.DTINTERVAL.start          = moment().format('DD/MM/YYYY');
		widget.currentRow.DTINTERVAL.formattedStart = moment().format('DD/MM/YYYY');
		widget.currentRow.DTINTERVAL.end            = moment().format('DD/MM/YYYY');
		widget.currentRow.DTINTERVAL.formattedEnd   = moment().format('DD/MM/YYYY');

		widget.getField('NMTIPOCUSTO').reload().then(callback => {
			let typeOfCost = callback.dataset.type_cost_lang;
			if(typeOfCost && typeOfCost.length){
				let currentCost = typeOfCost[0];
				if(currentCost){
					Object.assign(widget.currentRow, currentCost);
				}
			}
		});
	};

	this.retornaCurvaABC = function(currentRow) {
		return restEngine.post('cus_relatorio#/cus01400_retorna_curva', {
			"requestType": "Row",
			"row": currentRow
		}, null, null, null, null, 350000);
	};

	this.excluiConsplanCus01400 = function() {
		return restEngine.post('cus_relatorio#/cus01400_exclui_consplan', {
			"requestType": "Row",
			"row": {}
		});
	};
	
	this.validaNivel = function(currentRow, field) {
        var mensagem = "O produto final não pode ser maior que o inicial.";
        var retorno = '';
        
        if(currentRow.CDARVPRODINI && currentRow.CDARVPRODFINAL) {
            retorno = General.comparaPratoProduto(currentRow.CDARVPRODINI, currentRow.CDARVPRODFINAL, getLocalVar('CDPICTPROD'));
            if (!retorno) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            return true;
        }
        return false;
    };

	this.validaCampos = function(currentRow, widget, args) {
		let reportFormats = [
		    {
		        name: "pdf",
		        value: "PDF"
		    },
		    {
		        name: "xlsx",
		        value: "XLSX"
		    }
		];
	    if(widget.isValid() && self.validaNivel(currentRow)) {
			General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, args], reportFormats);
		}    
	};

	this.abreRelatorio = function (widget, currentRow, args, reportName) {	        
		if (widget.getField('IDMATEPRIM').checked || widget.getField('IDCONSFIXO').checked || widget.getField('IDCONSPERC').checked || widget.getField('IDNESTOCAVEIS').checked) {
			self.salvaFilial(widget);
			currentRow.DTINICIAL = currentRow.DTINTERVAL.start;
			currentRow.DTFINAL = currentRow.DTINTERVAL.end;
			currentRow.__report_name = currentRow.REPORT_NAME;
			currentRow.DTMESINIC = moment(currentRow.DTINICIAL, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
			currentRow.DTMESFINA = moment(currentRow.DTFINAL, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
			let IDMATEPRIM = widget.getField('IDMATEPRIM').checked ? 'C' : 'X';
			let IDCONSFIXO = widget.getField('IDCONSFIXO').checked ? 'F' : 'X';
			let IDCONSPERC= widget.getField('IDCONSPERC').checked ? 'P' : 'X';
			currentRow.IDPRODUTOS = IDMATEPRIM + IDCONSFIXO + IDCONSPERC;
			currentRow.CDPICTPROD = '!' + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
			
			General.openReport('cus_relatorio#/cus01400_curva_abc_geral_planejado', currentRow.__report_name, args.row);
		} else {
			ScreenService.showMessage("O Tipo de Produto deve ser informado");
		}	
	};

	this.salvaFilial = function(widget) {
		codigo  = widget.currentRow.CDFILIAL;
		unidade = widget.currentRow.NMFILIAL;
	};
	
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01400_CurvaABCGeralPlanController', Cus01400_CurvaABCGeralPlanController);
});