var Cus02700_CustoPadraoXRealizadoController = function(General, ScreenService, Parametros, GeneralServices) {
    /*global getLocalVar, moment */
    var self = this;
    
    this.defaultValues = function(widget) {

        if (!widget.currentRow.CDFILIAL) {
            widget.newRow();
            widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL');
            widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
        }

        GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			if(callback.dataset.defaulttipocusto[0]) {
			    widget.currentRow.CDTIPOCUSTOPLAN  = callback.dataset.defaulttipocusto[0].CDTIPOCUSTOPLAN;
			    widget.currentRow.NMTIPOCUSTOPLAN2 = callback.dataset.defaulttipocusto[0].CDTIPOCUSTOPLAN;
			    widget.currentRow.NMTIPOCUSTOPLAN  = callback.dataset.defaulttipocusto[0].NMTIPOCUSTOPLAN;
			    widget.currentRow.CDTIPOCUSTOREAL  = callback.dataset.defaulttipocusto[0].CDTIPOCUSTOREAL;
			    widget.currentRow.NMTIPOCUSTOREAL2 = callback.dataset.defaulttipocusto[0].CDTIPOCUSTOREAL;
			    widget.currentRow.NMTIPOCUSTOREAL  = callback.dataset.defaulttipocusto[0].NMTIPOCUSTOREAL;
				widget.redraw();
			}
		});

    };
    
    this.onChange = function (field){
		field.widget.currentRow[field.outData[field.valueField]] = field.widget.currentRow[field.name];
		field.widget.currentRow[field.outData[field.descriptionField]] = field.dataSource.data.filter(function(item){
			return item[field.valueField] === field.widget.currentRow[field.name];
		})[0][field.descriptionField];
	};
	
    
    this.onChangeAgrup = function(args) {
	    var agrupField = args.owner.field;
	    var widget = agrupField.widget;
	    var filialField = widget.getField('NMFILIAL');
	    
	    filialField.dataSourceFilter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": agrupField.value() ? widget.currentRow.CDGRUPFILI : "T"
            }
        ];
        
	    filialField.reload();
	    filialField.applyDefaultValue();
	    
	    self.onChangeFilial(widget);
	};
	
	this.onChangeFilial = function(widget) {
	    var agrupField = widget.getField("NMGRUPFILI");
	    var servicoField = widget.getField('NMSERVICO');
	    widget.currentRow.NMFILIAL = widget.currentRow.NMFILIAL == "" ? [] : widget.currentRow.NMFILIAL;
    	    servicoField.dataSourceFilter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": getLocalVar('CDOPERADOR')
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORG')
                },
                {
                    "name": "CDGRUPFILI",
                    "operator": "=",
                    "value": agrupField.value() ? widget.currentRow.CDGRUPFILI : "T"
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.ALLNMFILIAL == "T" ? "T" : widget.currentRow.NMFILIAL.join('_')
                }
            ];
            
            servicoField.reload();
            servicoField.applyDefaultValue();
	};
	
	this.verificaCheckboxTodos = function(currentRow) {
		if (currentRow.ALLNMFILIAL == 'N' && currentRow.NMSERVICO.length > 0) {
			currentRow.LISTAFILIAL = currentRow.NMFILIAL.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLNMFILIAL == 'T' && currentRow.NMSERVICO.length > 0) {
			currentRow.LISTAFILIAL = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLNMFILIAL == 'N' && currentRow.NMSERVICO.length == 0) {
			currentRow.LISTAFILIAL = currentRow.NMFILIAL.join('_');
			currentRow.LISTASERV = 'T';
		} else if (currentRow.ALLNMFILIAL == 'T' && currentRow.NMSERVICO.length == 0) {
			currentRow.LISTAFILIAL = 'T';
			currentRow.LISTASERV = 'T';
		}
	};
    
    this.openReport = function(widget, args) {        

        if(widget.isValid()) {
        var reportName = widget.currentRow.REPORT_NAME;
        var type = [
					{
						name: "pdf",
						value: "PDF"
					},
					{
						name: "xlsx",
						value: "XLSX"
					}
				];

            General.openReportPopup(widget, self.abreRelatorio, [widget, args, reportName, widget.currentRow], type);
        }
    };
    
    this.abreRelatorio = function(widget, args, reportName, currentRow) {
        self.verificaCheckboxTodos(currentRow);
        currentRow.DTMESINIC = moment(currentRow.PERIODO.formattedStart, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		currentRow.DTMESFINA = moment(currentRow.PERIODO.formattedEnd, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
        currentRow.DTINICIAL = currentRow.PERIODO.formattedStart;
        currentRow.DTFINAL = currentRow.PERIODO.formattedEnd;
        General.openReport('cus_relatorio#/Cus02700_CustoPadraoXRealizado', reportName, args.row);
    };

};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus02700_CustoPadraoXRealizadoController', Cus02700_CustoPadraoXRealizadoController);
});